package com.jproxy.samples.corba.test;

import javax.naming.*;
import java.util.*;
import java.io.*;
import java.rmi.RemoteException;

import com.jproxy.proxy.*;
import com.jproxy.samples.ejb.test.*;
import com.jproxy.samples.interfaces.ITest;
import com.jproxy.samples.interfaces.ITestCallback;

public class CORBAPerformanceClient
	extends PerformanceClient
	implements ITest
{
	Context context = null;
	Properties env = new Properties();
	Test test = null;

	public long getServerTime()
		throws RemoteException
	{
		return test.getServerTime();
	}

	public byte[] echoBytes(byte[] bytes)
		throws RemoteException
	{
		return test.echoBytes(bytes);
	}

	public void callbackBytes(Object callback, int numberOfBytes, int numberOfLoops)
		throws RemoteException
	{
		try{
			Tunnel tunnel = ((TunnelInvocationHandler)((Tunnelizable)test).getTunnelInvocationHandler()).getTunnel();
			byte[] bytes = Helper.serialize(callback, tunnel);
			test.callbackBytes(bytes, numberOfBytes, numberOfLoops);
		}
		catch(IOException e){
			e.printStackTrace();
		}
	}

	public void init()
		throws Exception
	{
		env.put(Context.PROVIDER_URL, hostUrl);
		env.put(Context.INITIAL_CONTEXT_FACTORY, "com.jproxy.proxy.NamingContextFactory");

		env.put(Tunnel.INITIAL_CONTEXT_FACTORY, "com.sun.jndi.cosnaming.CNCtxFactory");

		/* Sun CORBA */
		env.put(Tunnel.PROVIDER_URL, "iiop://localhost:1050");

		/* or for JBoss JacORB */
		/* env.put(Tunnel.PROVIDER_URL, "corbaloc::localhost:3528/JBoss/Naming/root");
		*/
		/** The line below is commented because the Linux KDE Konqueror Web Browser does not support
		* a standard way of obtaining InitialContext because of wrong definition of Java sand-box security.
		* For the browser "getClassLoader" permission is not allowed for sand-box.
		*/
		// context = new InitialContext(env);
		javax.naming.spi.InitialContextFactory factory = new com.jproxy.proxy.NamingContextFactory();
		context = factory.getInitialContext(env);

		/* no need to "narrow" stub. JProxy Server will do it automatically if necessary. You may leave "narrow" if you want. */
		test = (Test)context.lookup("test");

		context.close();
		session = this;
		isInitialized = true;
	}
}
