/*
to start CORBA nameserver:
  $JAVA_HOME/bin/orbd -ORBInitialPort 1050 &
to start JProxy CORBA Test Server:
  $JAVA_HOME/bin/java -cp samples.jar:proxyclient.jar com.jproxy.samples.corba.test.TestServer -ORBInitialPort 1050 &
*/

package com.jproxy.samples.corba.test;

import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;
import org.omg.CORBA.*;
import org.omg.PortableServer.*;
import org.omg.PortableServer.POA;


import java.util.*;

public class TestServer
{

	public static void main(String args[])
	{
		try{
/* Sun CORBA
*			props.put("org.omg.CORBA.ORBClass", "com.sun.CORBA.iiop.ORB");
*			props.put("org.omg.CORBA.ORBSingletonClass", "com.sun.CORBA.idl.ORBSingleton");
*/
/* JacORB CORBA
*			props.put("org.omg.CORBA.ORBClass", "org.jacorb.orb.ORB");
*			props.put("org.omg.CORBA.ORBSingletonClass", "org.jacorb.orb.ORBSingleton");
*			props.put("custom.props", "/opt/jboss/server/default/conf/jacorb.properties");
*/

			ORB orb = ORB.init(args, null);
			System.out.println("ORB: "+orb.getClass().getName());

			POA rootpoa = POAHelper.narrow(orb.resolve_initial_references("RootPOA"));
			rootpoa.the_POAManager().activate();

			// Create the servant and register it with the ORB
			TestImpl impl = new TestImpl();
			impl.setORB(orb);

			// get object reference from the servant
			org.omg.CORBA.Object ref = rootpoa.servant_to_reference(impl);
			Test href = TestHelper.narrow(ref);

			// get the root naming context
			org.omg.CORBA.Object objRef = orb.resolve_initial_references("NameService");
			// Use NamingContextExt which is part of the Interoperable
			// Naming Service (INS) specification.
			NamingContextExt ncRef = NamingContextExtHelper.narrow(objRef);

			// bind the Object Reference in Naming
			NameComponent path[] = ncRef.to_name("test");
			ncRef.rebind(path, href);

			System.out.println(
				"\r\n**********************************"+
				"\r\nCORBA Test "+
				"\r\nServer Time: "+(new Date(impl.getServerTime()))+
				"\r\nServer started. "+
				"\r\n**********************************\r\n");

			// wait for invocations from clients
			orb.run();
		}
		catch (Exception e){
			e.printStackTrace();
		}
	}
}