package com.jproxy.samples.ejb.test;

import javax.naming.*;
import java.util.*;

import java.security.Key;
import java.security.KeyStore;
import java.security.Principal;
import java.security.cert.Certificate;
import java.io.*;

import com.jproxy.samples.interfaces.ITest;
import com.jproxy.samples.interfaces.ITestCallback;

//	command line:
// java -cp samples.jar;proxyclient.jar;ejb.jar com.jproxy.samples.ejb.test.SessionClient [http | https://]YourServer[:Port]

public class EJBPerformanceClient
	extends PerformanceClient
{
	Context context = null;

	public void init()
		throws Exception
	{
		env.put(Context.PROVIDER_URL, hostUrl);
		env.put(Context.INITIAL_CONTEXT_FACTORY, "com.jproxy.proxy.NamingContextFactory");
		if(hostUrl!=null && hostUrl.toLowerCase().startsWith("https://"))
		{
			java.security.Provider provider = (java.security.Provider)Class.forName("com.sun.net.ssl.internal.ssl.Provider").newInstance();
			java.security.Security.addProvider(provider);
		}

		// for EJB security test:
//		 env.put(Context.SECURITY_PRINCIPAL, "admin");
//		 env.put(Context.SECURITY_CREDENTIALS, "12345678");

		/* JBoss without JProxy *
		/* env.put(Context.INITIAL_CONTEXT_FACTORY, "org.jnp.interfaces.NamingContextFactory");
		*  env.put(Context.URL_PKG_PREFIXES, "org.jboss.naming:org.jnp.interfaces");
		*/
		/** The line below is commented because the Linux KDE Konqueror Web Browser does not support
		* a standard way of obtaining InitialContext because of wrong definition of Java sand-box security.
		* For the browser "getClassLoader" permission is not allowed for sand-box.
		*/
//		context = new InitialContext(env);
		javax.naming.spi.InitialContextFactory factory = new com.jproxy.proxy.NamingContextFactory();
		context = factory.getInitialContext(env);

		ISessionHome sessionHome = (ISessionHome)context.lookup("TestSessionBean");
		context.close();
		session = sessionHome.create();
		isInitialized = true;
	}


	public void destroy()
	{
		if(isInitialized)
		try{
			isInitialized = false;
			((ISession)session).remove();
		}catch(Exception e){
		}
	}

}
