package com.jproxy.samples.ejb.test;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import java.net.URL;

public class PerformanceApplet
	extends java.applet.Applet
{
	TextArea message = new TextArea();
	TextField  serverUrl = new TextField();
	TextField  numberOfThreads = new TextField();
	TextField  numberOfLoops = new TextField();
	TextField  numberOfBytes = new TextField();
	Label remUrl;
	Choice mode = new Choice();

	PrintStream out = null;

	//Construct the applet
	public PerformanceApplet()
	{
		super();
	}

	public void stop()
	{
		System.out.println("Applet stopped");
		com.jproxy.proxy.Tunnel.init();
	}

	public void destroy()
	{
		System.out.println("Applet finalizer");
	}

	public URL getCodeBase()
	{
		try{
			return super.getCodeBase();
		}
		catch(Exception e){
		}
		return null;
	}

	//Initialize the applet
	public void init()
	{
		showComponents();

		message.setText("[log info:]\r\n");

		out = new PrintStream(new OutputStream()
		{
			StringBuffer buf = new StringBuffer();

			public void write(int b)
				throws IOException
			{
				buf.append((char)b);
			}
			public void flush()
				throws IOException
			{
				message.append("\r\n"+buf.toString());
				System.out.println(buf.toString());
				buf = new StringBuffer();
			}
		}, true);
	}

	//Destroy the applet
//	public void destroy()
//	{
//		System.out.println("In applet finalizer!");
//	}

	void showComponents()
	{
		setBackground(Color.white);
		setLayout(null);

		Font font = new Font("Arial", Font.BOLD, 20);
		String fontName = font.getName();
		font = new Font(fontName, Font.PLAIN, 14);

		int x = 10;
		int y = 10;
		int w = 500-2*x;

		Label label = new Label("JProxy Performance Test");
		label.setFont(font);
		label.setBounds(x, y, w, 60);
		add(label);

		y += 75;
		label = new Label("Test Case:");
		label.setBounds(x, y, 200, 20);
		add(label);
		mode.add(PerformanceClient.JPROXY_PERFORMANCE);
		mode.add(PerformanceClient.EJB_PERFORMANCE);
		mode.add(PerformanceClient.SOAP_PERFORMANCE);
		mode.add(PerformanceClient.RMI_PERFORMANCE);
		mode.add(PerformanceClient.CORBA_PERFORMANCE);
// The JMS test will be available in next release
// For now it immediatly works only on JBoss 3.x
// If you want to try it please remove comments around <message-driven> in samples.jar/META-INF/ejb-jar.xml
//		mode.add(PerformanceClient.JMS_PERFORMANCE);
		mode.select(0);
		mode.setBounds(w-100, y, 100, 20);
		add(mode);

		y += 25;
		label = new Label("Server URL:");
		label.setBounds(x, y, 200, 20);
		add(label);
		serverUrl.setFont(font);
		serverUrl.setBounds(w-250, y, 250, 20);
		String url = "localhost";
		if(getCodeBase()!=null)
			url = getCodeBase().getProtocol()+"://"+getCodeBase().getHost()+((getCodeBase().getPort()!=-1) ? ":"+getCodeBase().getPort(): "");

		serverUrl.setText(url);
		add(serverUrl);

		y += 25;
		label = new Label("Number of Threads (1-10):");
		label.setBounds(x, y, 200, 20);
		add(label);
		numberOfThreads.setFont(font);
		numberOfThreads.setBounds(w-40, y, 40, 20);
		numberOfThreads.setText("1");
		add(numberOfThreads);

		y += 25;
		label = new Label("Number of Loops (1-100):");
		label.setBounds(x, y, 200, 20);
		add(label);
		numberOfLoops.setFont(font);
		numberOfLoops.setBounds(w-40, y, 40, 20);
		numberOfLoops.setText("1");
		add(numberOfLoops);

		y += 25;
		label = new Label("Number of Bytes (0-100000):");
		label.setBounds(x, y, 200, 20);
		add(label);
		numberOfBytes.setFont(font);
		numberOfBytes.setBounds(w-80, y, 80, 20);
		numberOfBytes.setText("0");
		add(numberOfBytes);

		y += 25;
		Button  testButton = new Button("Test");
		testButton.setFont(font);
		testButton.setBounds(w-250, y, 90, 20);
		add(testButton);
		testButton.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				action(false);
			}
		});

		Button  testCallbackButton = new Button("Test Callback");
		testCallbackButton.setFont(font);
		testCallbackButton.setBounds(w-150, y, 150, 20);
		add(testCallbackButton);
		testCallbackButton.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				action(true);
			}
		});

		y += 25;
		message.setFont(font);
		message.setBackground(Color.lightGray);
		message.setEditable(false);
		message.setBounds(x, y, w-x, 125);
		add(message);
	}

	void action(boolean testCallback)
	{
		Properties props = new Properties();
		props.put("callback", ""+testCallback);

		props.put("threads", numberOfThreads.getText().trim());
		props.put("loops", numberOfLoops.getText().trim());
		props.put("bytes", numberOfBytes.getText().trim());
		props.put("url", serverUrl.getText().trim());
		props.put("mode", ""+mode.getSelectedItem());
		// the object is used only for keeping test parameters and passing them to executeTest(...)
		PerformanceClient client  = new PerformanceClient();
		PerformanceClient.out = out;
		try{
			client.validateArgs(props);
		}
		catch(Exception e){
			out.println(e.getMessage());
			return;
		}
		PerformanceClient.executeTest(client.isCallback, client.mode, client.hostUrl, client.loops, client.bytes, client.threads);
	}


	static public String replaceInString(String str, String oldStr, String newStr)
	{
		int newIndex = 0;
		int oldIndex = 0;
		boolean replaced = false;
		StringBuffer res = new StringBuffer("");
		while(true)
		{
			newIndex = str.indexOf(oldStr, oldIndex);
			if(newIndex==-1)
				break;
			res.append(str.substring(oldIndex, newIndex));
			res.append(newStr);
			oldIndex = newIndex + oldStr.length();
		}
		res.append(str.substring(oldIndex));
		return new String(res);
	}


	static Frame frame = null;
	public static void main(String[] arguments)
	{
		PerformanceApplet applet = new PerformanceApplet();
		applet.init();
		applet.start();

		frame = new Frame("JProxy Performance Test");
		frame.add("Center", applet);
		frame.setSize(500,400);
		frame.setLocation(100,100);
		frame.addWindowListener(new java.awt.event.WindowAdapter()
		{
			public void windowClosing(WindowEvent e)
			{
				frame.dispose();
//				System.exit(0);
			}
		});
		frame.show();
	}
}
