package com.jproxy.samples.ejb.test;

import javax.ejb.*;
import java.rmi.RemoteException;

import com.jproxy.samples.interfaces.*;

public class Test
	extends Base
	implements ITest
{
	byte[] buf = null;

	public long getServerTime()
		throws RemoteException
	{
//		System.out.println("TestSessionBean: CallerPrincipal:"+context.getCallerPrincipal());
		long time = System.currentTimeMillis();
		System.out.println(new java.util.Date(time));
		return time;
	}

	public byte[] echoBytes(byte[] bytes)
		throws RemoteException
	{
		if(bytes==null)
			throw new RemoteException("RemoteException test: wrong parameter: null");
		System.out.println("[JProxy EJB Test] echoBytes: bytes: "+bytes.length);
		return bytes;
	}

	public void callbackBytes(Object/*ITestCallback*/ callback, int numberOfBytes, int numberOfLoops)
		throws RemoteException
	{
		System.out.println("[JProxy EJB Test] callbackBytes: bytes: "+numberOfBytes+" loops: "+numberOfLoops);
		byte[] buf = new byte[numberOfBytes];
		for(int i=0; i<numberOfBytes; i++)
			buf[i] = (byte)(i & 0xFF);

		for(int i=0; i<numberOfLoops; i++)
		{
			System.out.println("[JProxy EJB Test] callbackBytes: loop: "+i+" sending to client "+numberOfBytes+" bytes ...");
			try{
				java.lang.reflect.Method method = callback.getClass().getMethod("onCallback", new Class[]{Object.class});
				Object res = method.invoke(callback, new Object[]{buf});
				if(res!=null)
				{
					String resultMessage = (res instanceof byte[]) ? ((byte[])res).length+" bytes" : res.getClass().getName()+" "+res.toString();
					System.out.println("[JProxy EJB Test] callbackBytes: result from callback: "+resultMessage);
				}
			}
			catch(Throwable e){e.printStackTrace();}
/* The code can be used on JBoss instead of code above
*			((ITestCallback)callback).onCallback(buf);
*/
		}
	}

}
