package com.jproxy.samples.rmi.test;

import javax.naming.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import java.rmi.RemoteException;

import com.jproxy.proxy.*;
import com.jproxy.samples.ejb.test.*;
import com.jproxy.samples.interfaces.ITest;
import com.jproxy.samples.interfaces.ITestCallback;

public class RMIPerformanceClient
	extends PerformanceClient
{
	Context context = null;
	Properties env = new Properties();

	public void init()
		throws Exception
	{
		env.put(Context.PROVIDER_URL, hostUrl);
		env.put(Context.INITIAL_CONTEXT_FACTORY, "com.jproxy.proxy.NamingContextFactory");

		/** The line below is commented because the Linux KDE Konqueror Web Browser does not support
		* a standard way of obtaining InitialContext because of wrong definition of Java sand-box security.
		* For the browser "getClassLoader" permission is not allowed for sand-box.
		*/
		// context = new InitialContext(env);
		javax.naming.spi.InitialContextFactory factory = new com.jproxy.proxy.NamingContextFactory();
		context = factory.getInitialContext(env);

		/* no need to "narrow" stub. JProxy Server will do it automatically if necessary. You may leave "narrow" if you want. */
		session = (ITest)context.lookup("test");

		context.close();
		isInitialized = true;
	}
}
