package com.jproxy.samples.rmi.test;

import java.rmi.*;
import java.rmi.server.UnicastRemoteObject;
import com.jproxy.samples.interfaces.*;

public class TestImpl
	extends UnicastRemoteObject
	implements TestRmi
{
	public TestImpl()
		throws RemoteException
	{
	}

	public long getServerTime()
		throws RemoteException
	{
		long time = System.currentTimeMillis();
		System.out.println(new java.util.Date(time));
		return time;
	}

	public byte[] echoBytes(byte[] bytes)
		throws RemoteException
	{
		System.out.println("[JProxy RMI Test] echoBytes: bytes: "+bytes.length);
		return bytes;
	}

	public void callbackBytes(Object/*ITestCallback*/ callback, int numberOfBytes, int numberOfLoops)
		throws RemoteException
	{
		System.out.println("[JProxy RMI Test] callbackBytes: bytes: "+numberOfBytes+" loops: "+numberOfLoops);
		byte[] buf = new byte[numberOfBytes];
		for(int i=0; i<numberOfBytes; i++)
			buf[i] = (byte)(i & 0xFF);

		for(int i=0; i<numberOfLoops; i++)
			((ITestCallback)callback).onCallback(buf);
	}
}
