package com.jproxy.samples.soap.test;

import javax.xml.namespace.QName;
import javax.xml.rpc.*;
import java.net.*;

import java.util.*;
import java.io.*;

import com.jproxy.proxy.*;
//import com.jproxy.samples.interfaces.ITest;

public class SOAPPerformanceClient
	extends com.jproxy.samples.ejb.test.PerformanceClient
{
	public void init()
		throws Exception
	{
		/* either method can be used to get Service and Service Port:
		* initAxisWay();// or:
		*/
		initAxisWay();
//		initStandardWay();
	}


	public void initAxisWay()
		throws Exception
	{
		/* In Axis Service and ServicePort can be obtained via axis-specific ServiceLocator binding generated by axis.
		* The method is used in original Axis samples.
		* The commented code below uses the method to create via JProxy on the server instance of ServiceLocator.
		*/
		com.jproxy.samples.soap.test.ITestService service = (com.jproxy.samples.soap.test.ITestService)Tunnel.newInstance(
		 		hostUrl,
				"com.jproxy.samples.soap.test.ITestServiceLocator",
				new String[]{com.jproxy.samples.soap.test.ITestService.class.getName(), javax.xml.rpc.Stub.class.getName()},
				new Class[]{},
				new Object[]{});
		 session = service.getJProxyTest();
	}

	public void initStandardWay()
		throws Exception
	{
		/* By using the method of obtaining Service and ServicePort you do not need to have on your client
		* any Axis-specific generated stubs and locators, just remote interface and type definitions!
		*/
        QName name = new QName("urn:JProxy","ITestService");
        QName portName = new QName("urn:JProxy","JProxyTest");
        String wsdlPath = Thread.currentThread().getContextClassLoader().getResource("com/jproxy/samples/soap/test/test.wsdl").toString();
        URL wsdlLocation = null;
        try {
            wsdlLocation = new URL(wsdlPath);
        } catch (java.net.MalformedURLException ex) {
            wsdlLocation = new File(wsdlPath).toURL();
        }
		/* Lines below are commented because it causes security exception in applet runnenig in standard secure "sand-box".
		* You may set the default factory in java.home/lib/jaxrpc.properties
		* or in some jar-file under META-INF/services/javax.xml.rpc.ServiceFactory
		* check JAXRPC spec or source of javax.xml.rpc.FactoryFinder.java (method find(...)) for details.
		*
		* System.setProperty(ServiceFactory.SERVICEFACTORY_PROPERTY, "com.jproxy.proxy.JProxyServiceFactory");
		* ServiceFactory factory = ServiceFactory.newInstance();
		*/
		ServiceFactory factory = new com.jproxy.proxy.JProxyServiceFactory();
        Service service = factory.createService(wsdlLocation, name);
        session = (ITest)service.getPort(portName, ITest.class);
	}
}
